<html>
<head>
<title>Ogre::Renderable::Visitor Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Renderable.html">Renderable</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Renderable_1_1Visitor.html">Visitor</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Renderable::Visitor Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Renderable::Visitor" -->
<p><a class="el" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Visitor</a> object that can be used to iterate over a collection of <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> instances abstractly.  
 <a href="classOgre_1_1Renderable_1_1Visitor.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreRenderable_8h_source.html">OgreRenderable.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Renderable_1_1Visitor-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable_1_1Visitor.html#a67b2d4e6dc274102523fde6b20d79ff5">~Visitor</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor needed as class has virtual methods.  <a href="#a67b2d4e6dc274102523fde6b20d79ff5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable_1_1Visitor.html#acc21c51c774281b1030860b8c72c315e">visit</a> (<a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *rend, <a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> lodIndex, bool isDebug, <a class="el" href="classOgre_1_1Any.html">Any</a> *pAny=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic visitor method.  <a href="#acc21c51c774281b1030860b8c72c315e"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Visitor</a> object that can be used to iterate over a collection of <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> instances abstractly. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Different scene objects use <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> differently; some will have a single <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, others will have many. This visitor interface allows classes using <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> to expose a clean way for external code to get access to the contained <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> instance(s) that it will eventually add to the render queue. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>To actually have this method called, you have to call a method on the class containing the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> instances. One example is <a class="el" href="classOgre_1_1MovableObject.html#a572b6aaa7a8b412163184a6c68ca3fa0" title="Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject ...">MovableObject::visitRenderables</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h_source.html#l00376">376</a> of file <a class="el" href="OgreRenderable_8h_source.html">OgreRenderable.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a67b2d4e6dc274102523fde6b20d79ff5"></a><!-- doxytag: member="Ogre::Renderable::Visitor::~Visitor" ref="a67b2d4e6dc274102523fde6b20d79ff5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1Renderable_1_1Visitor.html#a67b2d4e6dc274102523fde6b20d79ff5">Ogre::Renderable::Visitor::~Visitor</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Virtual destructor needed as class has virtual methods. </p>

<p>Definition at line <a class="el" href="OgreRenderable_8h_source.html#l00380">380</a> of file <a class="el" href="OgreRenderable_8h_source.html">OgreRenderable.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="acc21c51c774281b1030860b8c72c315e"></a><!-- doxytag: member="Ogre::Renderable::Visitor::visit" ref="acc21c51c774281b1030860b8c72c315e" args="(Renderable *rend, ushort lodIndex, bool isDebug, Any *pAny=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Renderable_1_1Visitor.html#acc21c51c774281b1030860b8c72c315e">Ogre::Renderable::Visitor::visit</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *&#160;</td>
          <td class="paramname"><em>rend</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td>
          <td class="paramname"><em>lodIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDebug</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Any.html">Any</a> *&#160;</td>
          <td class="paramname"><em>pAny</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generic visitor method. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rend</td><td>The <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> instance being visited </td></tr>
    <tr><td class="paramname">lodIndex</td><td>The LOD index to which this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> belongs. Some objects support LOD and this will tell you whether the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> you're looking at is from the top LOD (0) or otherwise </td></tr>
    <tr><td class="paramname">isDebug</td><td>Whether this is a debug renderable or not. </td></tr>
    <tr><td class="paramname">pAny</td><td>Optional pointer to some additional data that the class calling the visitor may populate if it chooses to. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreRenderable_8h_source.html">OgreRenderable.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
